package java.io;

public class PrintStream
{
    public PrintStream( java.io.OutputStream ostrm ) {}
    
    /**
     * Not normally native - we cheat to save memory
     */
    private native void write( String s );

    /**
     * Normally String and Integer do the conversion, but the Taurus VM
     * provides a more compact native conversion to save memory.  To do a more
     * portable conversion simply use a version of this class without this
     * defined.
     */
    private native void write( int n );

    private native void newLine();

    //
    
    public void print( boolean b )
    {
	    write( b ? "true" : "false" );
    }

    public void print( int i )
    {
	    write( i );                         // Taurus specific code
    }
    
    public void print( String s )
    {
    	if( s == null )
    	    s = "null";
    	
    	write(s);
    }

    public void println()
    {
	    newLine();
    }
    
    public void println( boolean b )
    {
	    synchronized( this )
	    {
	        print(b);
	        newLine();
	    }
    }

    public void println( int i )
    {
	    synchronized( this )
	    {
    	    print(i);
    	    newLine();
	    }
    }

    public void println( String s )
    {
	    synchronized( this )
	    {
	        print(s);
	        newLine();
	    }
    }
}
